module ("xiaoqiang.util.XQErrorUtil", package.seeall)

function getErrorMessage(errorCode)
    local errorList = {}
    -- 如果code大于1000 则是需要打印msg到客户端
    errorList[1501] = _("设置初始化状态失败")
    errorList[1502] = _("输入不能够为空")
    errorList[1503] = _("设置路由器名称失败")
    errorList[1504] = _("检查更新失败")
    errorList[1505] = _("文件MD5值校验失败,文件下载不完整")
    errorList[1506] = _("没有可用更新")
    errorList[1507] = _("文件不存在或者已经损坏,可以尝试重新下载")
    errorList[1508] = _("MAC地址不合法")
    errorList[1509] = _("文件上传失败")
    errorList[1510] = _("文件不存在或者已经损坏")
    errorList[1511] = _("不支持此语言")
    errorList[1512] = _("文件上传到服务器失败")
    errorList[1513] = _("恢复配置数据失败")
    errorList[1514] = _("路由器名称设置失败")
    errorList[1515] = _("路由器管理密码设置失败")
    errorList[1516] = _("Wifi设置失败")
    errorList[1517] = _("Wifi密码设置失败")
    errorList[1518] = _("外网设置失败")
    errorList[1519] = _("初始设置有未能成功")
    errorList[1520] = _("Wifi密码不能少于8位")
    errorList[1521] = _("Wifi密码应为8~63位")
    errorList[1522] = _("Wifi密码应为5位或13位")
    errorList[1523] = _("参数错误")
    errorList[1524] = _("未能检测上网类型")
    errorList[1525] = _("IP地址不合法")
    errorList[1526] = _("局域网IP不能与外网IP在同一网段.")
    errorList[1527] = _("局域网IP不合法,合法范围为10.0.0.0~10.255.255.255或172.16.0.0~172.23.255.255或192.168.0.0~192.168.255.255")
    errorList[1528] = _("用户名或密码不能为空")
    errorList[1529] = _("外网设置失败")
    errorList[1530] = _("静态IP地址不合法")
    errorList[1531] = _("子网掩码不合法")
    errorList[1532] = _("默认网关不合法")
    errorList[1533] = _("外网IP不合法,合法范围为1.0.0.0~126.255.255.255或128.0.0.0~223.255.255.255")
    errorList[1534] = _("结束地址应高于起始地址")
    errorList[1535] = _("IP范围应为2~254之间")
    errorList[1536] = _("DHCP租用时间范围为2~2880分钟,或1~48小时")
    errorList[1537] = _("参数有误")
    errorList[1538] = _("登录失败")
    errorList[1539] = _("未能获取到用户信息")
    errorList[1540] = _("请求失败")
    errorList[1541] = _("绑定当前路由器失败")
    errorList[1542] = _("您的路由器还未绑定小米账号")
    errorList[1543] = _("获取管理列表失败")
    errorList[1544] = _("获取插件列表失败")
    errorList[1545] = _("开启插件失败")
    errorList[1546] = _("关闭插件失败")
    errorList[1547] = _("获取插件信息失败")
    errorList[1548] = _("该账号不具备此路由器的管理权限")
    errorList[1549] = _("该小米账号已经解绑，您可以用管理账号登录并重新绑定")
    errorList[1550] = _("解绑失败")
    errorList[1551] = _("获取路由器管理列表失败，可能由于路由器系统时间不正确导致")
    errorList[1552] = _("原密码不正确")
    errorList[1553] = _("设置管理密码失败，密码不合法")
    errorList[1554] = _("文件校验失败")
    errorList[1555] = _("系统刷写失败")
    errorList[1556] = _("账号验证失败,请检查网络是否正常密码是否正确")
    errorList[1557] = _("密码不能够为空")
    errorList[1558] = _("格式化硬盘失败")
    errorList[1559] = _("datacenter服务工作不正常")
    errorList[1560] = _("后台已经在执行刷写操作")
    errorList[1561] = _("获取个人信息失败")
    errorList[1562] = _("没有授权")
    errorList[1563] = _("下载资源不可访问，可能是外网不通或者资源已经失效")
    errorList[1564] = _("用户名或密码错误")
    errorList[1565] = _("未能获取到授权信息,可能服务器异常")
    errorList[1566] = _("网络繁忙,服务器无响应")
    errorList[1567] = _("系统检测失败")
    errorList[1568] = _("已经在执行系统升级,请等待")
    errorList[1569] = _("设置数据访问权限失败")
    errorList[1570] = _("上传文件太大，不能超过128M")
    errorList[1571] = _("没有足够存储空间")
    errorList[1572] = _("名字过长，请使用短一些的名字")
    errorList[1573] = _("请输入标准字符，如 Xiaomi.Luyouqi")
    errorList[1574] = _("未能获取到当前模式")
    errorList[1575] = _("设置模式失败")
    errorList[1576] = _("状态信息获取失败")
    errorList[1577] = _("已经升级过,请手动重启路由器")
    errorList[1578] = _("路由器已经没有足够的空间,上传失败")
    errorList[1579] = _("已经在刷写固件，不可以取消")
    errorList[1580] = _("该账号没有路由器的管理权限,您可以尝试退出重新登录")
    errorList[1581] = _("服务器授权已过期,您需要重新登录")
    errorList[1582] = _("nonce 验证错误")
    errorList[1583] = _("VPN设置失败")
    -- For vpn
    errorList[1584] = _("用户名或密码验证失败")
    errorList[1585] = _("无法连接服务器")
    errorList[1586] = _("服务器连接异常，请重试")
    errorList[1587] = _("该接口不允许外网访问")
    errorList[1588] = _("测速失败,您可以尝试重新测试")
    errorList[1589] = _("没有磁盘，请插入磁盘")
    errorList[1590] = _("MTU不正确,合法范围为576 ~ 1492字节")
    errorList[1591] = _("添加失败,最多只能添加32个设备")
    errorList[1592] = _("IP/MAC地址不合法")
    errorList[1593] = _("IP地址冲突,请更换IP地址")
    errorList[1594] = _("MAC地址解除绑定失败")
    errorList[1595] = _("开启失败,请检查开发者ID是否有效")
    errorList[1600] = _("获取开发者信息失败")
    errorList[1601] = _("关闭失败")
    errorList[1602] = _("拨号状态获取失败")
    errorList[1603] = _("认证失败（用户密码异常导致）")
    errorList[1604] = _("无法连接服务器")
    errorList[1605] = _("其他异常（协议不匹配等）")
    errorList[1606] = _("操作失败")
    errorList[1607] = _("QoS并未开启,禁止该操作")
    errorList[1608] = _("端口号有冲突,请检查后重新设置")
    errorList[1609] = _("由于DMZ功能开启,无法设置端口转发")
    errorList[1610] = _("由于端口转发功能开启,无法设置DMZ")
    errorList[1611] = _("工作模式冲突")
    errorList[1612] = _("缺少参数")
    errorList[1613] = _("参数中IP地址有冲突")
    errorList[1614] = _("未能查询到该项信息")
    errorList[1615] = _("访客WiFi设置失败，请检查无线名称和密码")
    errorList[1616] = _("未能连接到指定WiFi")
    errorList[1617] = _("未能扫描到指定WiFi")
    errorList[1618] = _("当前工作在无线中继模式下，不可以设置有线中继")
    errorList[1619] = _("设置有线中继失败，未能获取到IP")
    errorList[1620] = _("国家码有误，请重新选择")
    errorList[1621] = _("未能获取到PPPoE帐号信息")
    errorList[1622] = _("磁盘无需修复")
    errorList[1623] = _("外网不通")
    errorList[1624] = _("该接口只能远程调用")
    errorList[1625] = _("未能获取到该设备的信息，可能该设备已经断开连接")
    errorList[1626] = _("操作失败，可能该设备已经断开连接")
    errorList[1627] = _("配置备份失败")
    errorList[1628] = _("配置文件不存在")
    errorList[1629] = _("解压失败，可能文件已经损坏")
    errorList[1630] = _("文件过大")
    errorList[1631] = _("没有发现IP冲突或者已经解决,您无需修复")
    errorList[1632] = _("最多只能添加5条")
    errorList[1633] = _("无效的ID")
    errorList[1634] = _("只有开启VPN才能使用该功能")
    errorList[1635] = _("操作过于频繁，将禁止访问30分钟")
    errorList[1636] = _("无效的参数")
    errorList[1637] = _("MAC地址是组播地址，请重新输入")
    errorList[1638] = _("正在扫描磁盘，请稍等")
    errorList[1639] = _("一键换机过程中发生未知的内部错误")
    errorList[1640] = _("一键换机过程中获取对端信息失败")
    errorList[1641] = _("一键换机过程中传输配置文件失败")
    errorList[1642] = _("一键换机过程中遇到未知的工作模式")
    errorList[1643] = _("一键换机过程中请求对端接口失败")
    errorList[1644] = _("旧路由无硬盘")
    errorList[1645] = _("新路由无硬盘")
    errorList[1646] = _("对端路由器不支持此功能")
    errorList[1647] = _("本端ip配置失败")
    errorList[1648] = _("dhcp操作不支持")
    errorList[1649] = _("本端有地址冲突")
    errorList[1650] = _("本端ip配置出错")
    errorList[1651] = _("对端配置脚本出错")
    errorList[1652] = _("对端有地址冲突")
    errorList[1653] = _("旧路由管理密码错误")
    errorList[1654] = _("旧路由nonce错误")
    errorList[1655] = _("认证失败")
    errorList[1656] = _("2.4GWIFI未开启")

    if (errorList[errorCode] == nil) then
        return translate(_("未知错误"))
    else
        return translate(errorList[errorCode])
    end
end
